;; SPDX-FileCopyrightText 2023–2024 toastal <toastal@posteo.net>
;; SPDX-License-Identifier: LGPL-2.1-or-later
; extends

(["fun" "function"] @keyword.function @conceal (#set! conceal "λ"))
("rec" @type.qualifier @conceal (#set! conceal "Γ"))
("->" @punctuation.delimeter @conceal (#set! conceal "→"))
("<-" @punctuation.delimeter @conceal (#set! conceal "←"))
(";;" @punctuation.delimeter @conceal (#set! conceal "◊"))
("::" @operator @conceal (#set! conceal "∷"))
(let_binding ("=" @operator.assignment (#set! conceal "≕")))
(let_binding (":=" @operator.assignment (#set! conceal "≔")))

(constructor_declaration ("*" @operator @conceal (#set! conceal "×")))
(tuple_type ("*" @operator @conceal (#set! conceal "×")))

(((rel_operator) @operator (#eq? @operator "<>")) (#set! conceal "≠"))
(((rel_operator) @operator (#eq? @operator "==")) (#set! conceal "≡"))
(((rel_operator) @operator (#eq? @operator "!=")) (#set! conceal "≢"))
(((rel_operator) @operator (#eq? @operator "<=")) (#set! conceal "≤"))
(((rel_operator) @operator (#eq? @operator ">=")) (#set! conceal "≥"))
((and_operator) @operator @conceal (#set! conceal "∧"))
((or_operator) @operator @conceal (#set! conceal "∨"))

(((value_name) @function.call (#eq? @function.call "not")) (#set! conceal "¬"))
(((value_name) @function.call (#eq? @function.call "sqrt")) (#set! conceal "√"))

(((type_constructor) @type.builtin (#eq? @type.builtin "int")) (#set! conceal "ℤ"))
(((type_constructor) @type.builtin (#eq? @type.builtin "bool")) (#set! conceal "𝔹"))

(((type_variable) @variable (#eq? @variable "'alpha")) (#set! conceal "ά"))
(((type_variable) @variable (#eq? @variable "'beta")) (#set! conceal "β́"))
(((type_variable) @variable (#eq? @variable "'gamma")) (#set! conceal "γ́"))
(((type_variable) @variable (#eq? @variable "'delta")) (#set! conceal "δ́"))
(((type_variable) @variable (#eq? @variable "'epsilon")) (#set! conceal "έ"))
(((type_variable) @variable (#eq? @variable "'zeta")) (#set! conceal "ζ́"))
(((type_variable) @variable (#eq? @variable "'eta")) (#set! conceal "ή"))
(((type_variable) @variable (#eq? @variable "'theta")) (#set! conceal "θ́"))
(((type_variable) @variable (#eq? @variable "'iota")) (#set! conceal "ί"))
(((type_variable) @variable (#eq? @variable "'kappa")) (#set! conceal "κ́"))
(((type_variable) @variable (#eq? @variable "'lambda")) (#set! conceal "λ́"))
(((type_variable) @variable (#eq? @variable "'mu")) (#set! conceal "μ́"))
(((type_variable) @variable (#eq? @variable "'nu")) (#set! conceal "ν́"))
(((type_variable) @variable (#eq? @variable "'xi")) (#set! conceal "ξ́"))
(((type_variable) @variable (#eq? @variable "'omicron")) (#set! conceal "ό"))
(((type_variable) @variable (#eq? @variable "'pi")) (#set! conceal "π́"))
(((type_variable) @variable (#eq? @variable "'rho")) (#set! conceal "ρ́"))
(((type_variable) @variable (#eq? @variable "'sigma")) (#set! conceal "σ́"))
(((type_variable) @variable (#eq? @variable "'tau")) (#set! conceal "τ́"))
(((type_variable) @variable (#eq? @variable "'upsilon")) (#set! conceal "ύ"))
(((type_variable) @variable (#eq? @variable "'phi")) (#set! conceal "φ́"))
(((type_variable) @variable (#eq? @variable "'chi")) (#set! conceal "χ́"))
(((type_variable) @variable (#eq? @variable "'psi")) (#set! conceal "ψ́"))
(((type_variable) @variable (#eq? @variable "'omega")) (#set! conceal "ώ"))

(((value_name) @variable (#eq? @variable "alpha")) (#set! conceal "α"))
(((value_name) @variable (#eq? @variable "beta")) (#set! conceal "β"))
(((value_name) @variable (#eq? @variable "gamma")) (#set! conceal "γ"))
(((value_name) @variable (#eq? @variable "delta")) (#set! conceal "δ"))
(((value_name) @variable (#eq? @variable "epsilon")) (#set! conceal "ε"))
(((value_name) @variable (#eq? @variable "zeta")) (#set! conceal "ζ"))
(((value_name) @variable (#eq? @variable "eta")) (#set! conceal "η"))
(((value_name) @variable (#eq? @variable "theta")) (#set! conceal "θ"))
(((value_name) @variable (#eq? @variable "iota")) (#set! conceal "ι"))
(((value_name) @variable (#eq? @variable "kappa")) (#set! conceal "κ"))
(((value_name) @variable (#eq? @variable "lambda")) (#set! conceal "λ"))
(((value_name) @variable (#eq? @variable "mu")) (#set! conceal "μ"))
(((value_name) @variable (#eq? @variable "nu")) (#set! conceal "ν"))
(((value_name) @variable (#eq? @variable "xi")) (#set! conceal "ξ"))
(((value_name) @variable (#eq? @variable "omicron")) (#set! conceal "ο"))
(((value_name) @variable (#eq? @variable "pi")) (#set! conceal "π"))
(((value_name) @variable (#eq? @variable "rho")) (#set! conceal "ρ"))
(((value_name) @variable (#eq? @variable "sigma")) (#set! conceal "σ"))
(((value_name) @variable (#eq? @variable "tau")) (#set! conceal "τ"))
(((value_name) @variable (#eq? @variable "upsilon")) (#set! conceal "υ"))
(((value_name) @variable (#eq? @variable "phi")) (#set! conceal "φ"))
(((value_name) @variable (#eq? @variable "chi")) (#set! conceal "χ"))
(((value_name) @variable (#eq? @variable "psi")) (#set! conceal "ψ"))
(((value_name) @variable (#eq? @variable "omega")) (#set! conceal "ω"))

(((constructor_name) @constructor (#eq? @constructor "Alpha")) (#set! conceal "Α"))
(((constructor_name) @constructor (#eq? @constructor "Beta")) (#set! conceal "Β"))
(((constructor_name) @constructor (#eq? @constructor "Gamma")) (#set! conceal "Γ"))
(((constructor_name) @constructor (#eq? @constructor "Delta")) (#set! conceal "Δ"))
(((constructor_name) @constructor (#eq? @constructor "Epsilon")) (#set! conceal "Ε"))
(((constructor_name) @constructor (#eq? @constructor "Zeta")) (#set! conceal "Ζ"))
(((constructor_name) @constructor (#eq? @constructor "Eta")) (#set! conceal "Η"))
(((constructor_name) @constructor (#eq? @constructor "Theta")) (#set! conceal "Θ"))
(((constructor_name) @constructor (#eq? @constructor "Iota")) (#set! conceal "Ι"))
(((constructor_name) @constructor (#eq? @constructor "Kappa")) (#set! conceal "Κ"))
(((constructor_name) @constructor (#eq? @constructor "Lambda")) (#set! conceal "Λ"))
(((constructor_name) @constructor (#eq? @constructor "Mu")) (#set! conceal "Μ"))
(((constructor_name) @constructor (#eq? @constructor "Nu")) (#set! conceal "Ν"))
(((constructor_name) @constructor (#eq? @constructor "Xi")) (#set! conceal "Ξ"))
(((constructor_name) @constructor (#eq? @constructor "Omicron")) (#set! conceal "Ο"))
(((constructor_name) @constructor (#eq? @constructor "Pi")) (#set! conceal "Π"))
(((constructor_name) @constructor (#eq? @constructor "Rho")) (#set! conceal "Ρ"))
(((constructor_name) @constructor (#eq? @constructor "Sigma")) (#set! conceal "Σ"))
(((constructor_name) @constructor (#eq? @constructor "Tau")) (#set! conceal "Τ"))
(((constructor_name) @constructor (#eq? @constructor "Upsilon")) (#set! conceal "Υ"))
(((constructor_name) @constructor (#eq? @constructor "Phi")) (#set! conceal "Φ"))
(((constructor_name) @constructor (#eq? @constructor "Chi")) (#set! conceal "Χ"))
(((constructor_name) @constructor (#eq? @constructor "Psi")) (#set! conceal "Ψ"))
(((constructor_name) @constructor (#eq? @constructor "Omega")) (#set! conceal "Ω"))
